﻿UseSQLiteDatabase()
;07:09,17.02.24 start coding
;17:06 fix with add to tree
;4:54,18.02.2024 menu
;8:30 ,18.02.2024 combobox+treeview
;14:34 ,18.02.2024 drag'n'drop done
;8:57,19.02.2024 menu 'add folder' 9:01-done CHECK drag'n'drop.9:17,20.02.2024 start,9:19 done
;15:02,19.02.2024 expand/collapse 15:06 - done
;6:46,20.02.2024 delete folder 6:54 done
;https://learnsql.com/blog/query-parent-child-tree/
Enumeration
  #tv
  #cbf
EndEnumeration

Enumeration
  #file_add
  #file_del
  #file_quit
  #view_exp
  #view_col
  #view_ontop
EndEnumeration

Structure dire
  id.l
  n.s
  pid.l
EndStructure

Global NewList ftree.dire()

Global TableName.s="dir1"

Global p$="d:\freeware\"

Procedure.s deapo(s.s)
  ProcedureReturn ReplaceString(s,"'","''")
EndProcedure

Procedure.s adds(s.s)
  If Right(s,1)<>"\"
    s+"\"
  EndIf
  ProcedureReturn s
EndProcedure

Procedure ex(lv,d$,pid)
  If ExamineDirectory(lv, d$, "*.*")  
    While NextDirectoryEntry(lv)
      If DirectoryEntryType(lv) = #PB_DirectoryEntry_Directory
        dd$=DirectoryEntryName(lv)
        If dd$<>"." And dd$<>".."
          ;Debug dd$
          StatusBarText(0, 0, dd$)
          WindowEvent()
          If DatabaseUpdate(1, "insert into "+tablename+"(name,parentid) values('"+deapo(dd$)+"','"+Str(pid)+"')")
            DatabaseQuery(1,"select last_insert_rowid()")
            NextDatabaseRow(1)
            ex(lv+1,d$+dd$+"\",GetDatabaseLong(1,0))
          Else
            Debug DatabaseError()
          EndIf
        EndIf
      EndIf
    Wend
    FinishDirectory(lv)
  EndIf
  
EndProcedure

Procedure filltv(lid,sl)
  ForEach ftree()
    If ftree()\pid=lid
      subl=ftree()\pid
      AddGadgetItem (#tv, -1, ftree()\n, 0, sl)
      PushListPosition(ftree())
      sl+1
      filltv(ftree()\id,sl)
      sl-1
      PopListPosition(ftree())
      
    EndIf
  Next
EndProcedure

;- fill combobox with paths
Procedure fillcb()
  ClearGadgetItems(#cbf)
  If OpenDatabase(1,"wd.db","","")
    If DatabaseQuery(1, "select * from folders")
      cbi=0
      While NextDatabaseRow(1)
        AddGadgetItem(#cbf,cbi,GetDatabaseString(1,1))
        SetGadgetItemData(#cbf,cbi,GetDatabaseLong(1,0))
        cbi+1
      Wend
    Else
      MessageRequester("DB error",DatabaseError())
    EndIf
    CloseDatabase(1)
  EndIf
EndProcedure

Procedure settree()
  ClearGadgetItems(#tv)
  ClearList(ftree())
  If OpenDatabase(1,"wd.db","","")
    DatabaseQuery(1,"select * from "+TableName)
    While NextDatabaseRow(1)
      AddElement(ftree())
      ftree()\id=GetDatabaseLong(1,0)
      ftree()\n=GetDatabaseString(1,1)
      ftree()\pid=GetDatabaseLong(1,2)
    Wend
    CloseDatabase(1)
  EndIf
  filltv(0,0)
EndProcedure

Procedure addfolder()
  If OpenDatabase(1,"wd.db","","")
    If DatabaseUpdate(1,"insert into folders(fpath) values('"+deapo(p$)+"')")=0
      Debug DatabaseError()
    EndIf
    DatabaseQuery(1,"select last_insert_rowid()")
    NextDatabaseRow(1)
    pid=GetDatabaseLong(1,0)
    tablename="dir"+Str(pid)
    If DatabaseUpdate(1, "create table "+tablename+"(id integer PRIMARY KEY, name text,parentid integer)")=0
      Debug DatabaseError()
    EndIf
    If DatabaseUpdate(1, "insert into "+tablename+"(name,parentid) values('"+deapo(p$)+"','0')")=0
      Debug DatabaseError()
    EndIf
    DatabaseQuery(1,"select last_insert_rowid()")
    NextDatabaseRow(1)
    pid=GetDatabaseLong(1,0)
    ex(0,p$,pid)
    CloseDatabase(1)
  EndIf
  
EndProcedure

;https://www.purebasic.fr/english/viewtopic.php?t=63276
Procedure TreeViewExpandAll(Gadget.l) 
  hwndTV.l = GadgetID(Gadget)  
  hRoot.l = SendMessage_(hwndTV, #TVM_GETNEXTITEM, #TVGN_ROOT, 0)  
  hItem.l = hRoot  
  Repeat 
    SendMessage_(hwndTV, #TVM_EXPAND, #TVE_EXPAND, hItem) 
    hItem = SendMessage_(hwndTV, #TVM_GETNEXTITEM, #TVGN_NEXTVISIBLE , hItem)  
  Until hItem = #Null  
  SendMessage_(hwndTV, #TVM_ENSUREVISIBLE, 0, hRoot) 
EndProcedure

Procedure TreeViewCollapseAll(Gadget.l) 
  hwndTV.l = GadgetID(Gadget)  
  hRoot.l = SendMessage_(hwndTV, #TVM_GETNEXTITEM, #TVGN_ROOT, 0)  
  hItem.l = hRoot  
  Repeat 
    SendMessage_(hwndTV, #TVM_EXPAND, #TVE_COLLAPSE, hItem) 
    hItem = SendMessage_(hwndTV, #TVM_GETNEXTITEM, #TVGN_NEXTVISIBLE , hItem)  
  Until hItem = #Null  
  SendMessage_(hwndTV, #TVM_ENSUREVISIBLE, 0, hRoot) 
EndProcedure 


;--start program

;Goto skippy
If FileSize("wd.db")<0
  CreateFile(0, "wd.db")
  CloseFile(0)
  
  ;start scan
  If OpenDatabase(1,"wd.db","","")
    DatabaseUpdate(1, "create table folders(fid integer PRIMARY KEY, fpath text)")
    CloseDatabase(1)
  EndIf
EndIf;skippy:


If OpenWindow(0, 0, 0, 640, 480, "WinDir", #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
  TreeGadget(#tv, 0, 20, 640, 400)
  ComboBoxGadget(#cbf,0,0,640,20):GadgetToolTip(#cbf, "All stored path")
  EnableGadgetDrop(#tv,#PB_Drop_Files,#PB_Drag_Copy)
  
  If CreateStatusBar(0, WindowID(0))
    AddStatusBarField(100)
    StatusBarText(0, 0, "folders")
  EndIf
  
  If CreateMenu(0, WindowID(0))
    MenuTitle("File")
    MenuItem(#file_add, "Add foilder tree")
    MenuItem(#file_del, "Delete folder tree")
    MenuBar()
    MenuItem(#file_quit, "Quit")
    MenuTitle("View")
    MenuItem(#view_exp, "Expand")
    MenuItem(#view_col, "Collapse")
    MenuBar()
    MenuItem(#view_ontop, "Stay on top")
  EndIf
  
  fillcb()
  
  ;- Event loop
  Repeat
    ev=WaitWindowEvent()
    Select ev
      Case #PB_Event_GadgetDrop
        tp$=EventDropFiles()
        tp$=StringField(tp$,1,Chr(10))
        If FileSize(tp$)=-2
          p$=adds(tp$)
          addfolder()
          fillcb()
          settree()
        EndIf
        
      Case #PB_Event_Gadget
        Select EventGadget()
          Case #cbf
            If EventType()=#PB_EventType_Change
              ii=GetGadgetState(#cbf)
              If ii>=0
                ii=GetGadgetItemData(#cbf,ii)
                If ii>0
                  TableName="dir"+Str(ii)
                  settree()
                EndIf
              EndIf
            EndIf
        EndSelect
        
      Case #PB_Event_Menu
        Select EventMenu()
          Case #file_quit
            Break
          Case #file_del
            If MessageRequester("Delete folder tree", "Sure", #PB_MessageRequester_YesNo)=#PB_MessageRequester_Yes 
            ii=GetGadgetState(#cbf)
            If ii>=0
              ii=GetGadgetItemData(#cbf,ii)
              If ii>0
                If OpenDatabase(1,"wd.db","","")
                  If DatabaseUpdate(1, "drop table dir"+Str(ii))=0
                    Debug DatabaseError()
                  EndIf
                  If DatabaseUpdate(1, "delete from folders where fid="+Str(ii))=0
                    Debug DatabaseError()
                  EndIf
                  CloseDatabase(1)
                EndIf
                fillcb()
                ClearGadgetItems(#tv)
              EndIf
            EndIf
            EndIf
            
          Case #file_add
            tp$=PathRequester("Please choose your path", "C:\")
            If tp$<>"" And FileSize(tp$)=-2
              p$=adds(tp$)
              addfolder()
              fillcb()
              settree()
            EndIf
          Case #view_col
            TreeViewCollapseAll(#tv)
          Case #view_exp
            TreeViewExpandAll(#tv)
          Case #view_ontop
            im=1-GetMenuItemState(0,#view_ontop)
            SetMenuItemState(0,#view_ontop,im)
            StickyWindow(0,im)
        EndSelect
        
    EndSelect
  Until ev = #PB_Event_CloseWindow
EndIf


; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 242
; FirstLine = 220
; Folding = --
; EnableUnicode
; EnableXP
; UseIcon = wd.ico
; Executable = wd.exe